Loading...
Searching...
No Matches
shiftgb.h File Reference
`#include "kernel/structs.h"`
`#include "polys/nc/nc.h"`

Go to the source code of this file.

## Macros

#define | pLPCopyAndShiftLM(p, sh)
#define | pmLPmaxPossibleShift(p)

## Functions

poly | p_LPCopyAndShiftLM (poly p, int sh, const ring r)
int | p_mLPmaxPossibleShift (poly p, const ring r)

## Macro Definition Documentation

## pLPCopyAndShiftLM

#define pLPCopyAndShiftLM | ( |  | p,
|  |  | sh )

Value:
p_LPCopyAndShiftLM(p, sh, currRing)
p
int p
Definition cfModGcd.cc:4086
currRing
VAR ring currRing
Widely used global variable which specifies the current polynomial ring for Singular interpreter and ...
Definition polys.cc:13
p_LPCopyAndShiftLM
poly p_LPCopyAndShiftLM(poly p, int sh, const ring r)
Definition shiftgb.cc:35

Definition at line 15 of file shiftgb.h.

## pmLPmaxPossibleShift

#define pmLPmaxPossibleShift | ( |  | p | ) |

Value:
p_mLPmaxPossibleShift(p, currRing)
p_mLPmaxPossibleShift
int p_mLPmaxPossibleShift(poly p, const ring r)
Definition shiftgb.cc:45

Definition at line 18 of file shiftgb.h.

## Function Documentation

## p_LPCopyAndShiftLM()

poly p_LPCopyAndShiftLM | ( | poly | p,
|  | int | sh,
|  | const ring | r )

Definition at line 35 of file shiftgb.cc.

{
if (sh == 0 || p == NULL) return p;
poly q = p_Head(p, r);
p_mLPshift(q, sh, r);
pNext(q) = pNext(p);
return q;
}
pNext
#define pNext(p)
Definition monomials.h:36
NULL
#define NULL
Definition omList.c:12
p_Head
static poly p_Head(const poly p, const ring r)
copy the (leading) term of p
Definition p_polys.h:862
p_mLPshift
void p_mLPshift(poly m, int sh, const ring ri)
Definition shiftop.cc:362

## p_mLPmaxPossibleShift()

int p_mLPmaxPossibleShift | ( | poly | p,
|  | const ring | r )

Definition at line 45 of file shiftgb.cc.

{
int lastBlock = p_mLastVblock(p, r);
if (lastBlock == 0) return 0;
int uptodeg = r->N/r->isLPring;
return uptodeg - lastBlock;
}
p_mLastVblock
int p_mLastVblock(poly p, const ring ri)
Definition shiftop.cc:421